ESX = nil
local PlayerData = {}

ESX = exports["es_extended"]:getSharedObject()


RegisterNetEvent('esx:playerLoaded')
AddEventHandler('esx:playerLoaded', function(xPlayer)
	while true do
		if ESX == nil then
			Citizen.Wait(1)
		else
			ESX.PlayerData = xPlayer
			break
		end
	end
end)

RegisterNetEvent('esx:setJob')
AddEventHandler('esx:setJob', function(job)
	ESX.PlayerData.job = job
end)

Modules.DriftCounter = {}
Modules.DriftCounter.IsEnabled = true
Modules.DriftCounter.IsDrifting = false
Modules.DriftCounter.CurrentPoints = 0
Modules.DriftCounter.CurrentAngle = 0 -- Only refreshed when the player is drifting
Modules.DriftCounter.ChainCooldown = ConfigShared.DriftChainTime
Modules.DriftCounter.ChainLoopStarted = false
Modules.DriftCounter.ChainTimeLeft = 0
Modules.DriftCounter.GlobalAlpha = 0
if ConfigShared.devmod then
    Modules.DriftCounter.GlobalAlpha = 255
end
Modules.DriftCounter.InAnimation = false
Modules.DriftCounter.CachedAllowedVeh = {}
local lastDamage = 0


--[[===================]] 
--[[=== DRIFTA DUMI ===]] 
--[[===================]] 

local _SIZE = 0.2
local _DENS = 10
local _BURNOUT_SIZE = 1.5
local _SMOKE_ON = true
local bone_list = {"wheel_lr","wheel_rr"}
leaderboardoff = false

function Request(name)
    RequestNamedPtfxAsset(name)
    while not HasNamedPtfxAssetLoaded(name) do
        Wait(1)
    end
end

function DriftSmoke(base, sub, car, dens, size)
    all_part = {}
    for i = 0,dens do
        UseParticleFxAssetNextCall(base)
        W1 = StartParticleFxLoopedOnEntityBone(sub, car, 0.05, 0, 0, 0, 0, 0, GetEntityBoneIndexByName(car, bone_list[1]), size, 0, 0, 0)

        UseParticleFxAssetNextCall(base)
        W2 = StartParticleFxLoopedOnEntityBone(sub, car, 0.05, 0, 0, 0, 0, 0, GetEntityBoneIndexByName(car, bone_list[2]), size, 0, 0, 0)

        table.insert(all_part, 1, W1)
        table.insert(all_part, 2, W2)
    end
    Citizen.Wait(1000)
    for _,W1 in pairs(all_part) do
        StopParticleFxLooped(W1, true)
    end
end


-- Source: https://github.com/Blumlaut/FiveM-DriftCounter/blob/master/driftcounter_c.lua
-- Lot of math stuff i don't understand, thanks Blumlaut
function Modules.DriftCounter.GetCurrentAngle()
    if Modules.Player.IsPedInAnyVehicle() then
        local veh = Modules.Player.GetCurrentVehicle()
        local vx,vy,_ = table.unpack(GetEntityVelocity(veh))
        local modV = math.sqrt(vx*vx + vy*vy)


        local _,_,rz = table.unpack(GetEntityRotation(veh,0))
        local sn,cs = -math.sin(math.rad(rz)), math.cos(math.rad(rz))

        if GetEntitySpeed(veh)* 3.6 < 25 or GetVehicleCurrentGear(veh) == 0 then return 0,modV end --speed over 25 km/h

        local cosX = (sn*vx + cs*vy)/modV
        return math.deg(math.acos(cosX))*0.5, modV
    else
        return 0
    end
end

-- Cleaning the cache to avoid any memory leak as the system will load up every vehicule entity the player goes in. If the entity is deleted or not in range it will be removed from the list to avoid memory leaks
function Modules.DriftCounter.CleanUpCache()
    for veh, allowed in pairs(Modules.DriftCounter.CachedAllowedVeh) do
        if not DoesEntityExist(veh) then
            Modules.DriftCounter.CachedAllowedVeh[veh] = nil
        end
    end
end

function Modules.DriftCounter.IsVehiculeAllowedToDrift(pVeh)
    if ConfigShared.UseVehicleWhitelist then
        if Modules.DriftCounter.CachedAllowedVeh[pVeh] == nil then
            local pVehModel = GetEntityModel(pVeh)
            if ConfigShared.WhitelistedVehicules[pVehModel] ~= nil then
                Modules.DriftCounter.CachedAllowedVeh[pVeh] = true
            else
                Modules.DriftCounter.CachedAllowedVeh[pVeh] = false
            end
            Modules.DriftCounter.CleanUpCache()
        else
            return Modules.DriftCounter.CachedAllowedVeh[pVeh] -- Using a cache system allow better performance, we don't check the vehicle model every time.
        end
    else
        return true
    end
end

function Modules.DriftCounter.IsPlayerDrifting()
    local ped = PlayerPedId()
    local coords = GetEntityCoords(ped)
    if(GetDistanceBetweenCoords(coords,ConfigShared.ZoneCoordsX, ConfigShared.ZoneCoordsY, ConfigShared.ZoneCoordsZ, true) < ConfigShared.ZoneRadius) or ConfigShared.WholeMap then
        if Modules.Player.IsPedInAnyVehicle() then
            local pVeh = Modules.Player.GetCurrentVehicle()
            if Modules.DriftCounter.IsVehiculeAllowedToDrift(pVeh) then
                if GetEntityHeightAboveGround(pVeh) <= 1.5 then
                    if Modules.Player.GetPed() == GetPedInVehicleSeat(pVeh, -1) then
                        Modules.DriftCounter.CurrentAngle = Modules.DriftCounter.GetCurrentAngle()
                        if Modules.DriftCounter.CurrentAngle > 10 then
                            return true
                        else
                            return false
                        end
                    else
                        return false
                    end
                else
                    return false
                end
            end
        else
            return false
        end
    end
end

function Modules.DriftCounter.StartChainBreakLoop()
    if not Modules.DriftCounter.ChainLoopStarted then
        Modules.DriftCounter.ChainLoopStarted = true
        if ConfigShared.UseDefaultUI then
            Modules.DriftCounter.FadeInHud()
        end
        TriggerEvent(ConfigShared.DriftStartEvent)
        Citizen.CreateThread(function()
            Modules.Utils.RealWait(Modules.DriftCounter.ChainCooldown, function(cb, timeLeft)
                Modules.DriftCounter.ChainTimeLeft = timeLeft - (timeLeft * 2) -- Duh
                if Modules.DriftCounter.IsDrifting then
                    cb(false, ConfigShared.DriftChainTime)
                end
            end)
            if ConfigShared.UseDefaultUI then
                Modules.DriftCounter.FadeOutHud()
            end
            TriggerEvent(ConfigShared.DriftFinishedEvent, Modules.DriftCounter.CurrentPoints)
            TriggerEvent("drift:GetCurrentDriftScore", function(score)
                if score > 10 then
                print("Drift Points: ", score) 
                local nosaukums = GetLabelText(GetDisplayNameFromVehicleModel(GetEntityModel(GetVehiclePedIsIn(PlayerPedId(), false))))
                local atalgojums = math.floor((score*ConfigShared.RewardMultiplier)+0.5)
                if ConfigShared.ScoreLimits then
                    if score > ConfigShared.MaxScore then
                        atalgojums = ConfigShared.MaxScore*ConfigShared.RewardMultiplier
                        ESX.ShowNotification("You finished the drift with "..score.." points! Reward: "..atalgojums.." $", false, true, 180)
                    elseif score < ConfigShared.MinScore then
                        atalgojums = 0
                        ESX.ShowNotification("You finished the drift with "..score.." points! Finishing with at least "..ConfigShared.MinScore.." points will give you a reward from the Drift Zone sponsors", false, true, 180)
                    else
                        ESX.ShowNotification("You finished the drift with "..score.." points! Reward: "..atalgojums.." $", false, true, 180)
                    end
                else
                    ESX.ShowNotification("You finished the drift with "..score.." points! Reward: "..atalgojums.." $", false, true, 180)
                end
                TriggerServerEvent('drift:server:addEgg', score)
                TriggerServerEvent('drift:pabeidza2', score, nosaukums)
                end
            end)
            Modules.DriftCounter.ChainCooldown = ConfigShared.DriftChainTime
            Modules.DriftCounter.ChainLoopStarted = false
            Modules.DriftCounter.CurrentPoints = 0
            Modules.DriftCounter.CurrentAngle = 0
            Modules.DriftCounter.ChainTimeLeft = 0
        end)
    end
end

function Modules.DriftCounter.FadeInHud()
    Citizen.CreateThread(function()
        Modules.DriftCounter.InAnimation = true
        while Modules.DriftCounter.GlobalAlpha < 255 do
            Modules.DriftCounter.GlobalAlpha = Modules.DriftCounter.GlobalAlpha + (0.5 * Modules.Utils.TimeFrame)
            Wait(0)
        end
        Modules.DriftCounter.InAnimation = false
        Modules.DriftCounter.GlobalAlpha = 255
    end)
end

function Modules.DriftCounter.FadeOutHud()
    Citizen.CreateThread(function()
        Modules.DriftCounter.InAnimation = false
        Modules.DriftCounter.GlobalAlpha = 0
    end)
end

local pirmais = true
local irbijisieksa = false

Citizen.CreateThread(function()
    while true do
        local sleep = 1000
        local ped = PlayerPedId()
        local coords = GetEntityCoords(ped)
        if(GetDistanceBetweenCoords(coords,ConfigShared.ZoneCoordsX, ConfigShared.ZoneCoordsY, ConfigShared.ZoneCoordsZ, true) < ConfigShared.ZoneRadius) or ConfigShared.WholeMap then
                if Modules.Player.IsPedInAnyVehicle() and leaderboardoff==false then
                    ieksa1()
                    irbijisieksa = true
                    pirmais = false
                end
            if Modules.Player.IsPedInAnyVehicle() then
                sleep = 100
                local ped = GetPlayerPed(-1)
                local currentveh = GetVehiclePedIsIn(ped, false)
                lastDamage = GetEntityHealth(currentveh)
                if Modules.DriftCounter.IsEnabled then -- Check we're enabled
                    if Modules.DriftCounter.IsPlayerDrifting() then
                        sleep = 0
                            Modules.DriftCounter.IsDrifting = true
                            Modules.DriftCounter.StartChainBreakLoop()
                            if Modules.DriftCounter.CurrentAngle > 10 then
                                if ConfigShared.AddPointBasedOnAngle then
                                    Modules.DriftCounter.CurrentPoints = math.floor(Modules.DriftCounter.CurrentPoints + (Modules.DriftCounter.CurrentAngle / 100) * Modules.Utils.TimeFrame) -- This fix the issue where player with low fps would get less point then player with high fps count.
                                end

                                if ConfigShared.AddStaticPointOnDrifting then
                                    Modules.DriftCounter.CurrentPoints = math.floor(Modules.DriftCounter.CurrentPoints + ConfigShared.StaticPointToAdd * Modules.Utils.TimeFrame) -- This fix the issue where player with low fps would get less point then player with high fps count. 
                                end
                            end
                    else
                        Modules.DriftCounter.IsDrifting = false
                        if Modules.DriftCounter.ChainLoopStarted then
                            Wait(0) -- Chain active, so we need to check if the player start drifting again or not as fast as possible
                        else
                            Wait(100) -- Could be longer i guess, but will take more time to detect if the player is drifting or not.
                        end
                    end
                    local ped = GetPlayerPed(-1)
                    local currentveh = GetVehiclePedIsIn(ped, false)
                    currentHealth = GetEntityHealth(currentveh)
                    if Modules.Player.IsPedInAnyVehicle() then
                        if currentHealth < lastDamage then
                            sleep = 5000
                            lastDamage = currentHealth
                            ESX.ShowNotification("You crashed! Points have been reset.", false, true, 180)
                            Modules.DriftCounter.CurrentPoints = 0
                        end
                    end
                else
                    Wait(1000) -- Sleep if disabled
                end
            end
        else
            Modules.DriftCounter.IsDrifting = false
            Modules.DriftCounter.CurrentPoints = 0
            if irbijisieksa or leaderboardoff then
            ara()
            end
        end
        Wait(sleep)
    end
end)


Citizen.CreateThread(function()
    while true do
        sleep = 5000
        TriggerServerEvent('drift:server:getCurrent')
        Wait(sleep)
     end
 end)
Citizen.CreateThread(function()
    while true do
        local sleep = 1000
        local ped = PlayerPedId()
        local coords = GetEntityCoords(ped)
        base = "scr_recartheft"
        base2 = "core"
        Request(base)
        Request(base2)
        car = GetVehiclePedIsUsing(ped)
            if(GetDistanceBetweenCoords(coords,ConfigShared.ZoneCoordsX, ConfigShared.ZoneCoordsY, ConfigShared.ZoneCoordsZ, true) < ConfigShared.ZoneRadius) or ConfigShared.WholeMap then
                if Modules.Player.IsPedInAnyVehicle() then
                    -- sleep = 0
                    if Modules.DriftCounter.IsPlayerDrifting() then
                        sleep = 0
                        DriftSmoke(base,"scr_wheel_burnout", car, _DENS, _SIZE)
                    end
                end
            end
        Wait(sleep)
     end
 end)


Citizen.CreateThread(
    function()
        if ConfigShared.WholeMap == false then
            local radius = AddBlipForRadius(ConfigShared.BlipCoords, 360.0)
            SetBlipSprite(radius, 9)
            SetBlipColour(radius, 3)
            SetBlipAlpha(radius, 25)
            local blip = AddBlipForCoord(ConfigShared.BlipCoords)
            SetBlipSprite(blip, 326)
            SetBlipColour(blip, 3)
            SetBlipAsShortRange(blip, true)
            SetBlipScale(blip, 0.6)
            BeginTextCommandSetBlipName("STRING")
            AddTextComponentString("Drift Zone")
            EndTextCommandSetBlipName(blip)
        end
    end
)

AddEventHandler(ConfigShared.GetCurrentDriftScore, function(cb)
    cb(Modules.DriftCounter.CurrentPoints) 
end)

AddEventHandler(ConfigShared.IsDrifting, function(cb)
    cb(Modules.DriftCounter.IsDrifting) 
end)

AddEventHandler(ConfigShared.IsEnabled, function(cb)
    cb(Modules.DriftCounter.IsEnabled) 
end)

AddEventHandler(ConfigShared.EnableEvent, function()
    Modules.DriftCounter.IsEnabled = true
end)

AddEventHandler(ConfigShared.DisableEvent, function()
    Modules.DriftCounter.IsEnabled = false
end)

AddEventHandler(ConfigShared.ToggleEvent, function()
    Modules.DriftCounter.IsEnabled = not Modules.DriftCounter.IsEnabled
end)



Found = {}
Objects = {}


RegisterNetEvent('drift:client:update')
AddEventHandler('drift:client:update', function(place, name, score)
 SendNUIMessage({
        type = 'update',
        place = place,
        name = name,
        score = score
    })
    
end)

function ara(source, args)
    if ConfigShared.Leaderboard then
    SendNUIMessage({
        type = 'close'
    })
end
end

function ieksa1(source, args)
    if ConfigShared.Leaderboard then
        SendNUIMessage({
          type = 'open'
      })
    end
end


RegisterCommand('leaderboard', function ()
    SendNUIMessage({
        type = 'open'
    })
    TriggerServerEvent('drift:server:getCurrent')
    leaderboardoff = false
end)

RegisterCommand('leaderboardoff', function ()
    SendNUIMessage({
        type = 'close'
    })
    leaderboardoff=true
end)

